class_name Moving2CP extends EntityState


func process_idle(delta: float):
	var target_pos  = entity.target_cp.global_position
	var distance_to = entity.global_position.distance_to(target_pos)

	if distance_to > entity.MAX_DISTANCE_TO:
		entity.look_at(target_pos, Vector3.UP)
		apply_acceleration(delta, (target_pos - entity.global_position).normalized())
	else:
		transitioned.emit(self, "idle")


func apply_acceleration(delta: float, direction: Vector3 = Vector3.ZERO):
	anim_player.play(entity.MOVEMENT_ANIM, 0.2)

	entity.velocity.x = move_toward(entity.velocity.x, entity.SPEED * direction.x, entity.ACCELERATION * delta)
	entity.velocity.z = move_toward(entity.velocity.z, entity.SPEED * direction.z, entity.ACCELERATION * delta)

func enter():
	pass

func exit():
	entity.target_cp = null

func update(_delta: float):
	pass

func physics_update(delta: float):
	process_idle(delta)

