class_name Moving2Target extends EntityState


func process_moving_state(delta: float):
	var target_pos  = entity.target_enemy.global_position
	var distance_to = entity.global_position.distance_to(target_pos)
	var direction   = (target_pos - entity.global_position).normalized()

	if distance_to > entity.MAX_DISTANCE_TO:
		entity.look_at(target_pos, Vector3.UP)
		apply_acceleration(delta, direction)
	else:
		transitioned.emit(self, "shooting")

func apply_acceleration(delta: float, direction: Vector3 = Vector3.ZERO):
	anim_player.play(entity.RUN_ANIM, 0.2)

	entity.velocity.x = move_toward(entity.velocity.x, entity.SPEED * direction.x, entity.ACCELERATION * delta)
	entity.velocity.z = move_toward(entity.velocity.z, entity.SPEED * direction.z, entity.ACCELERATION * delta)


func process_moving_state_nav_agent(delta):
	entity.nav_agent.set_target_position(entity.target_enemy.global_position)

	var target_pos               = entity.nav_agent.get_next_path_position()
	var target_enemy_pos         = entity.target_enemy.global_position
	var distance_to_target_enemy = entity.global_position.distance_to(target_enemy_pos)
	var direction                = (target_pos - entity.global_position).normalized() * entity.SPEED

	if distance_to_target_enemy > entity.MAX_DISTANCE_TO:
		entity.look_at(target_pos, Vector3.UP)
		apply_acceleration_nav_agent(delta, direction)
	else:
		transitioned.emit(self, "shooting")

func apply_acceleration_nav_agent(_delta: float, direction: Vector3 = Vector3.ZERO):
	anim_player.play(entity.RUN_ANIM, 0.2)
	entity.nav_agent.set_velocity(direction)


func enter():
	pass

func exit():
	pass

func update(_delta: float):
	pass

func physics_update(delta: float):
	if not entity.target_enemy:
		transitioned.emit(self, "idle")
		return

	if entity.target_enemy.state_machine.current_state is Dead:
		transitioned.emit(self, "idle")
		return

	if not entity.USE_NAV_AGENT:
		process_moving_state(delta)
	else:
		process_moving_state_nav_agent(delta)





