class_name PersuingFlag extends EntityState


func process_idle(delta: float):
	var target_pos  = entity.target_ctf_flag.global_position
	var distance_to = entity.global_position.distance_to(target_pos)

	if distance_to > entity.MAX_DISTANCE_TO:
		entity.look_at(target_pos, Vector3.UP)
		apply_acceleration(delta, (target_pos - entity.global_position).normalized())
	else:
		# Note: Need to setup such that if flag free take it else if taken; 
		# target entity and shoot who has the flag
		transitioned.emit(self, "idle")


func apply_acceleration(delta: float, direction: Vector3 = Vector3.ZERO):
	anim_player.play(entity.MOVEMENT_ANIM, 0.2)

	entity.velocity.x = move_toward(entity.velocity.x, entity.SPEED * direction.x, entity.ACCELERATION * delta)
	entity.velocity.z = move_toward(entity.velocity.z, entity.SPEED * direction.z, entity.ACCELERATION * delta)

func enter():
	pass

func exit():
	entity.target_ctf_flag = null

func update(delta: float):
	pass

func physics_update(delta: float):
	process_idle(delta)

